﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace _110741
{
	public partial class Form1 : Form
	{
		List<DataRow> addedrows = new List<DataRow>();
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			DataTable dt = new DataTable();
			for (int i = 1; i < 13; i++)
			{
				dt.Columns.Add(Thread.CurrentThread.CurrentUICulture.DateTimeFormat.GetMonthName(i), typeof(string)).DefaultValue = "";
			}

			for (int i = 0; i < 20; i++)
            {
                object[] values = new object[12];

                for (int J = 0; J < 12; J++)
                    values[J] = "Text";
                dt.Rows.Add(values);
			}

			ultraGrid1.DataSource = dt;
			
			ultraGridExcelExporter1.ExportStarted += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportStartedEventHandler(ultraGridExcelExporter1_ExportStarted);
			ultraGridExcelExporter1.ExportEnded += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventHandler(ultraGridExcelExporter1_ExportEnded);
		}

		void ultraGridExcelExporter1_ExportEnded(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventArgs e)
		{
            foreach (DataRow row in addedrows)
                row.Delete();
            addedrows.Clear();
		}

		void ultraGridExcelExporter1_ExportStarted(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportStartedEventArgs e)
		{
			e.Layout.Override.AllowAddNew = AllowAddNew.Yes;
            e.Layout.Bands[0].Columns.Insert(4, "Sep Coll1").Header.Caption = "";
			e.Layout.Bands[0].Columns.Insert(8, "Sep Coll" ).Header.Caption = "";
            

            DataTable dt = (DataTable)ultraGrid1.DataSource;
            for (int i = 15; i > 0; i -= 5)
            {
                DataRow row = dt.NewRow();
                addedrows.Add(row);
                dt.Rows.InsertAt(row, i);
            }
		}

		

		private void ultraButton1_Click(object sender, EventArgs e)
		{
			ultraGridExcelExporter1.Export(ultraGrid1, "Test.xlsx");
			Process.Start("Test.xlsx");
		}
	}
}
